// Forlix SoBall
// http://forlix.org/, df@forlix.org
//
// Copyright (c) 2008-2011 Dominik Friedrichs

#include "_main.inc"

static bool:late_load = false;


public APLRes:AskPluginLoad2(Handle:myself,
                             bool:late,
                             String:error[],
                             err_max)
{
  late_load = late;
  return(APLRes_Success);
}


public OnPluginStart()
{
  HookEvent("round_start", Event_RoundStart);
  HookEvent("round_freeze_end", Event_RoundFreezeEnd);

  HookEvent("player_spawn", Event_PlayerSpawn);
  HookEvent("player_death", Event_PlayerDeath, EventHookMode_Pre);

  RegConsoleCmd(PLUGIN_COMMAND, SoccerMenu, "Opens the SoBall menu to spawn a soccer ball.");

  BuildSoBallMenu();
  SetupConVars();

  return;
}


public OnMapStart()
{
  decl String:path[PLATFORM_MAX_PATH];
  decl String:currentmap[32];

  GetCurrentMap(currentmap, sizeof(currentmap));
  BuildPath(Path_SM, path, sizeof(path), CONFIG_PATH);

  new Handle:excluded_maps = CreateKeyValues("excluded_maps");

  if(!FileToKeyValues(excluded_maps, path))
    SetFailState("Configuration file \"%s\" not found", path);

  if(!KvGetNum(excluded_maps, currentmap))
  {
    LoadTranslations(TRANSLATION_FILE);
    PrecacheResources();

    if(late_load)
      SetupEntities();
  }
  else
    UnloadWithMessage(EXCLUDED_MAP_MSG);

  CloseHandle(excluded_maps);

  late_load = false;
  return;
}


public OnConfigsExecuted()
{
  SetConVarFloat(FindConVar("phys_pushscale"), 900.0);
  return;
}


public OnClientConnected(client)
{
  p_spawned[client] = false;
  p_ballspawns[client] = 0;

  return;
}


PrecacheResources()
{
  AddFileToDownloadsTable("models/forlix/soccer/soccerball.dx80.vtx");
  AddFileToDownloadsTable("models/forlix/soccer/soccerball.dx90.vtx");
  AddFileToDownloadsTable("models/forlix/soccer/soccerball.mdl");
  AddFileToDownloadsTable("models/forlix/soccer/soccerball.phy");
  AddFileToDownloadsTable("models/forlix/soccer/soccerball.sw.vtx");
  AddFileToDownloadsTable("models/forlix/soccer/soccerball.vvd");
  AddFileToDownloadsTable("models/forlix/soccer/soccerball.xbox.vtx");
  AddFileToDownloadsTable("materials/models/forlix/soccer/soccerball.vmt");
  AddFileToDownloadsTable("materials/models/forlix/soccer/soccerball.vtf");

  PrecacheModel(SOCC_MODELFILE, true);

  PrecacheSound(SPAWN_SOUND, true);
  PrecacheSound(SPAWN_FAILURE_SOUND, true);

  PrefetchSound(SPAWN_SOUND);
  PrefetchSound(SPAWN_FAILURE_SOUND);

  return;
}


UnloadWithMessage(const String:message[])
{
  PrintToServer("%s", message);
  ServerCommand("sm plugins unload forlix_soball");

  return;
}
