// Forlix SoBall
// http://forlix.org/, df@forlix.org
//
// Copyright (c) 2008-2011 Dominik Friedrichs

// convar defaults
#define LOG_BALL_SPAWNS             "1"
#define ANNOUNCEMENT_TYPE           "0"

#define SPAWNPROTECTION_TIME        "2"
#define SPAWNCOUNT_PER_ROUND        "2"
#define SPAWNDISTANCE_MAX           "500"
#define ALLOW_SPAWN_ON_PLAYERS      "0"
#define KILL_CREDITING_TIME         "5"

#define CHAT_TRIGGER                "!"

static Handle:h_log_ball_spawns = INVALID_HANDLE;
static Handle:h_announcement_type = INVALID_HANDLE;

static Handle:h_spawnprotection_time = INVALID_HANDLE;
static Handle:h_spawncount_per_round = INVALID_HANDLE;
static Handle:h_spawndistance_max = INVALID_HANDLE;
static Handle:h_allow_spawn_on_players = INVALID_HANDLE;
static Handle:h_kill_crediting_time = INVALID_HANDLE;

static Handle:h_chat_trigger = INVALID_HANDLE;


SetupConVars()
{
  new Handle:version_cvar = CreateConVar(PLUGIN_VERSION_CVAR,
  PLUGIN_VERSION,
  "Forlix SoBall plugin version",
  FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_NOTIFY|FCVAR_PRINTABLEONLY);

  SetConVarString(version_cvar, PLUGIN_VERSION, false, false);

  h_log_ball_spawns = CreateConVar("forlix_soball_log_ball_spawns",
  LOG_BALL_SPAWNS,
  "Enables (1) or disables (0) ball spawn logging",
  0, true, 0.0, true, 1.0);

  h_announcement_type = CreateConVar("forlix_soball_announcement_type",
  ANNOUNCEMENT_TYPE,
  "How often the plugin may announce itself to players: Every round-start (0), Once after connect (1)",
  0, true, 0.0, true, 1.0);

  h_spawnprotection_time = CreateConVar("forlix_soball_spawnprotection_time",
  SPAWNPROTECTION_TIME,
  "Time in full seconds after freezetime end in which balls cannot be spawned",
  0, true, 0.0, true, 300.0);

  h_spawncount_per_round = CreateConVar("forlix_soball_spawncount_per_round",
  SPAWNCOUNT_PER_ROUND,
  "Amount of balls a player can spawn per round (0 for none)",
  0, true, 0.0, true, 200.0);

  h_spawndistance_max = CreateConVar("forlix_soball_spawndistance_max",
  SPAWNDISTANCE_MAX,
  "Maximum distance a player can spawn a ball at",
  0, true, 75.0, true, 20000.0);

  h_allow_spawn_on_players = CreateConVar("forlix_soball_allow_spawn_on_players",
  ALLOW_SPAWN_ON_PLAYERS,
  "Allow (1) or deny (0) spawning balls on players (aiming at them, then spawning)",
  0, true, 0.0, true, 1.0);

  h_kill_crediting_time = CreateConVar("forlix_soball_kill_crediting_time",
  KILL_CREDITING_TIME,
  "Time after a shot in full seconds in which kills are credited to the shooter (0 for indefinitely)",
  0, true, 0.0, true, 300.0);

  h_chat_trigger = CreateConVar("forlix_soball_chat_trigger",
  CHAT_TRIGGER,
  "Set this to one of the ChatTrigger strings configured in SourceMod's core.cfg",
  FCVAR_PRINTABLEONLY);

  HookConVarChange(h_log_ball_spawns, MyConVarChanged);
  HookConVarChange(h_announcement_type, MyConVarChanged);

  HookConVarChange(h_spawnprotection_time, MyConVarChanged);
  HookConVarChange(h_spawncount_per_round, MyConVarChanged);
  HookConVarChange(h_spawndistance_max, MyConVarChanged);
  HookConVarChange(h_allow_spawn_on_players, MyConVarChanged);
  HookConVarChange(h_kill_crediting_time, MyConVarChanged);

  HookConVarChange(h_chat_trigger, MyConVarChanged);

  // manually trigger convar readout
  MyConVarChanged(INVALID_HANDLE, "0", "0");

  return;
}


public MyConVarChanged(Handle:convar,
                       const String:oldValue[],
                       const String:newValue[])
{
  log_ball_spawns = GetConVarInt(h_log_ball_spawns);
  announcement_type = GetConVarInt(h_announcement_type);

  spawncount_per_round = GetConVarInt(h_spawncount_per_round);
  spawnprotection_time = GetConVarInt(h_spawnprotection_time);
  spawndistance_max = GetConVarInt(h_spawndistance_max);
  allow_spawn_on_players = GetConVarInt(h_allow_spawn_on_players);
  kill_crediting_time = GetConVarInt(h_kill_crediting_time);

  GetConVarString(h_chat_trigger, spawn_cmd, sizeof(spawn_cmd));
  StrCat(spawn_cmd, sizeof(spawn_cmd), PLUGIN_COMMAND);

  CancelSoBallMenu();
  return;
}
